// ****************************************************************
// REVISION NOTES ARE AT END OF THIS FILE.
// Last update 7/21/95.
// ****************************************************************

// Note that "shorts" are 2-byte ints.

// This is used to align structure bytes properly on both PowerPC and
// 68000 processors.

#if defined(powerc) || defined (__powerc) || GENERATINGPOWERPC
#pragma options align=mac68k
#endif

typedef struct
{
	short		quantity;
	char			name[40];
	char			prodCode[16];
	char			varCode[16];
	float			price;
	short		maxPurchase;
	short		minPurchase;
	short		editable;
	float			shUSA;
	float			shFOR;
}	purchaseItemType;

typedef struct
{
	char			name[40];
	float			price;
	short		maxPurchase;
	short		minPurchase;
	char			prodCode[16];
	float			shUSA;
	float			shFOR;
	short		numVarCodes;
	short		numPurchased;
	char			varCode1[16];
	char			varCode2[16];
	char			varCode3[16];
	char			varCode4[16];
	char			varCode5[16];
	char			varCode6[16];
	char			varCode7[16];
	char			varCode8[16];
	
}	catalogItemType, *catalogItemTypePtr;

typedef struct
{
	short			userAborted;				// AutoPay module sends
	short			userChoseWhichOption;		// these to your app...
	short			modemPaymentAccepted;
	short			userSuccessfullyTelUnlocked;
	short			userSuccessfullyMailUnlocked;
	short			modemPaymentIncludedReg;
	float				finalPurchaseAmount;
	char				orderNumber[16];
	char				serialNumber[30];
	char				unlockCode[30];	
	char				usersName[80];				
	
	char				programName[30];			// Your app sends these to
	char				programSource[20];			// the AutoPay module...
	char				encodeMeth[30];
	char				privateKey[30];
	char				programID[20];
	char				programPassword[20];
	short			returnSerialNum;
	short			areAdditionalItemsForSale;	
	char				*screenText[10];
	short			textSize[10];
	short			textFont[10];	
	short			numItemsInCatalog;
	catalogItemType	*catalogItem[20];	
	short			numItemsPrepurchased;
	purchaseItemType	prepurchaseItem[6];
	
} digiMonBlock;

// This tells compiler to reset any byte alignment changes made.

#if defined(powerc) || defined(__powerc) || GENERATINGPOWERPC
#pragma options align=reset
#endif

// Revision history follows:

// ****************************************************************
// These structures were revised on 1/21/95
// so that char[] arrays were all even lengths.
// This insures compatibility with Pascal development
// environments.

// Revised 1/25 to replace booleans with 2-byte ints (1=true, 0=false)

// Revised 2/11 to add new field (numPurchased) to catalogItemType.
// This is returned by the AutoPay Module to your program, in case
// you need to know what items were purchased. Items not purchased get
// a zero in this field.

// Also (2/11) added a new field to the DMCB. The field is called
// userSuccessfullyMailUnlocked. It is turned =1 when the user
// types in the proper unlocking code after receiving mail registration.

// Order of the DMCB fields also changed 2/11.

// Revised 5/5/95	Changed int declarations to shorts, set 68K alignment
//					for PowerPC code
// ****************************************************************

// Note that "shorts" are 2-byte ints.